#!/usr/bin/perl

# ARCADEmini converter: bml2ambin
# version 1.0 date 2004-06-16
# part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
# written by 1stein <1stein@schuermans.info>
# based on blinkenplayer.pl by stray <stray@stray.ch>
# Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

print <<EOF;
ARCADEmini converter: bml2ambin
version 1.0 date 2004-06-16
part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
written by 1stein <1stein\@schuermans.info>
based on blinkenplayer.pl by stray <stray\@stray.ch>
Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

EOF

if( @ARGV < 1 )
{
	print <<EOF;
syntax: bml2ambin <bml-file> [<ambin-file> [<amflash-file>]]

examples: bml2ambin example.bml
          bml2ambin example.bml example.ambin
          bml2ambin example.bml example.ambin example.amflash

EOF
	exit;
}

read_source( $ARGV[0] );

if( @ARGV < 2 ) { $file = $ARGV[0] . ".ambin"; } else { $file = $ARGV[1]; }
open( F, "> " . $file ) || die "Can't open output file \"$file\": $!\n";
binmode F;

if( @ARGV < 3 ) { $flash = 0; } else { $flash = 1; $file = $ARGV[2]; }
if( $flash ) { open( FF, "> " . $file ) || die "Can't open output file \"$file\": $!\n"; }

printf F "ARCADEmini 26x20/16 ambin 1.0   ";
for( $i = 32; $i < 512; $i++ ) { print F pack( 'C', 0xFF ); }
if( $flash )
{
	printf FF "amdata=EBFCEDEBEEEFGNGJGOGJCADCDGHIDCDACPDBDGCAGBGNGCGJGOCADBCODACACACA";
	for( $i = 32; $i < 512; $i++ ) { print FF "PP"; }
}

$char[0] = " ";
$char[1] = " ";
$char[2] = " ";
$char[3] = " ";
$char[4] = "+";
$char[5] = "+";
$char[6] = "+";
$char[7] = "+";
$char[8] = "*";
$char[9] = "*";
$char[10] = "*";
$char[11] = "*";
$char[12] = "#";
$char[13] = "#";
$char[14] = "#";
$char[15] = "#";

$bytes = 0;
$bytes_sector = 0;
$frames = 0;
$sectors = 0;
for( $f = 0; $f <= $#del; $f++) {

	$chars = @{@{$frames[$f]}[0]};
	if( $chars > 26 ) { $chars = 26 };
	$lines = @{$frames[$f]};
	if( $lines > 20 ) { $lines = 20 };
	$left = (26 - $chars) / 2;
	$right = 26 - $chars - $left;
	$top = (20 - $lines) / 2;
	$bottom = 20 - $lines - $top;

	$nibble = 0;
	for( $i = 0; $i < 26 * $top; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }
	$linenum = 0;
	foreach (@{$frames[$f]}) {
	  if( $linenum < 26 ) { for( $i = 0; $i < $left; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  $charnum = 0;
	  foreach (@$_) {
		print($char[int( $_ / 0x10 )]);
		if( $linenum < 20 && $charnum < 26 ) {
		  @nibbles[$nibble] = int( $_ / 0x10 );
		  $nibble++;
		}
		$charnum++;
	  }
	  if( $linenum < 26 ) { for( $i = 0; $i < $right; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  print("\n");
	  $linenum++;
	}
	for( $i = 0; $i < 26 * $bottom; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		if( $flash ) { for( $i = 0; $i < $fill; $i++ ) { print FF to_flash( 0 ); } }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	if( $flash ) { print FF to_flash( 0xA5 ); }
	print F pack( 'C', 0x00 );
	if( $flash ) { print FF to_flash( 0x00 ); }
	for( $byte = 0; $byte < 65; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 0x10 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
		if( $flash ) { print FF to_flash( $val ); }
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		if( $flash ) { for( $i = 0; $i < $fill; $i++ ) { print FF to_flash( 0 ); } }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	if( $flash ) { print FF to_flash( 0xA5 ); }
	print F pack( 'C', 0x01 );
	if( $flash ) { print FF to_flash( 0x01 ); }
	for( $byte = 65; $byte < 130; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
		if( $flash ) { print FF to_flash( $val ); }
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		if( $flash ) { for( $i = 0; $i < $fill; $i++ ) { print FF to_flash( 0 ); } }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	if( $flash ) { print FF to_flash( 0xA5 ); }
	print F pack( 'C', 0x02 );
	if( $flash ) { print FF to_flash( 0x02 ); }
	for( $byte = 130; $byte < 195; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
		if( $flash ) { print FF to_flash( $val ); }
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		if( $flash ) { for( $i = 0; $i < $fill; $i++ ) { print FF to_flash( 0 ); } }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	if( $flash ) { print FF to_flash( 0xA5 ); }
	print F pack( 'C', 0x03 );
	if( $flash ) { print FF to_flash( 0x03 ); }
	for( $byte = 195; $byte < 260; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
		if( $flash ) { print FF to_flash( $val ); }
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 4 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xC0 );
	if( $flash ) { print FF to_flash( 0xC0 ); }
	print F pack( 'C', 0xC9 );
	if( $flash ) { print FF to_flash( 0xC9 ); }
	print F pack( 'C', ($del[$f] >> 8) & 0xFF );
	if( $flash ) { print FF to_flash( ($del[$f] >> 8) & 0xFF ); }
	print F pack( 'C', $del[$f] & 0xFF );
	if( $flash ) { print FF to_flash( $del[$f] & 0xFF ); }
	$bytes += 4;
	$bytes_sector += 4;

	$frames++;
}

if( $bytes_sector > 0 )
{
	for( $i = 0; $i < 512 - $bytes_sector; $i++ ) { print F pack( 'C', 0 ); }
	if( $flash ) { for( $i = 0; $i < 512 - $bytes_sector; $i++ ) { print FF to_flash( 0 ); } }
	$bytes += 512 - $bytes_sector;
	$bytes_sector = 0;
	$frames_sector = 0;
	$sectors++;
}

$jump_sectors = 0xFFFFFFFF - ($sectors - 1);
print F pack( 'C', 0x01 );
print F pack( 'C', ($jump_sectors >> 24) & 0xFF );
print F pack( 'C', ($jump_sectors >> 16) & 0xFF );
print F pack( 'C', ($jump_sectors >> 8) & 0xFF );
print F pack( 'C', $jump_sectors & 0xFF );
for( $i = 5; $i < 512; $i++ ) { print F pack( 'C', 0x00 ); }
if( $flash )
{
	print FF to_flash( 0x01 );
	print FF to_flash( ($jump_sectors >> 24) & 0xFF );
	print FF to_flash( ($jump_sectors >> 16) & 0xFF );
	print FF to_flash( ($jump_sectors >> 8) & 0xFF );
	print FF to_flash( $jump_sectors & 0xFF );
	for( $i = 5; $i < 512; $i++ ) { print FF "AA"; }
}

if( $flash ) { print FF "&amloaded=1"; }

close F;
if( $flash ) { close FF; }

sub read_source
{
  my $file = shift;
  open( F, $file ) || die "Can't open input file \"$file\": $!\n";
  my $width = 26, $height = 20, $bits = 4, $channels = 1;
  foreach $line( <F> )
  {
    while( $line ne "" )
    {
      if( $line =~ s/^[^<]*<blm([^>]*)>// )
      {
        my $blm = $1;
        if( $blm =~ /width="?([0-9]*)"?/ )
        {
          $width = $1;
          if( $width < 1 ) { $width = 1 }
          if( $width > 1000 ) { $width = 1000 }
        }
        if( $blm =~ /height="?([0-9]*)"?/ )
        {
          $height = $1;
          if( $height < 1 ) { $height = 1 }
          if( $height > 1000 ) { $height = 1000 }
        }
        if( $blm =~ /bits="?([0-9]*)"?/ )
        {
          $bits = $1;
          if( $bits < 1 ) { $bits = 1 }
          if( $bits > 8 ) { $bits = 8 }
        }
        if( $blm =~ /channels="?([0-9]*)"?/ )
        {
          $channels = $1;
          if( $channels < 1 ) { $channels = 1 }
          if( $channels > 3 ) { $channels = 3 }
        }
      }
      elsif( $line =~ s/^[^<]*<frame([^>]*)>// )
      {
        my $frm = $1;
        my $duration = 1000;
        if( $frm =~ /duration="?([0-9]*)"?/ )
        {
          $duration = $1;
          if( $duration < 1 ) { $duration = 1 }
          if( $duration > 60000 ) { $duration = 60000 }
        }
        push(@del,$1);
        $frame = $#del;
      }
      elsif( $line =~ s/^[^<]*<row>([^<]*)<\/row>// )
      {
        my $row = $1;
        $row =~ s/[^0-9A-Fa-f]//g;
        my $chrs = int( ($bits + 3) / 4 );
        my $maxval = ((1 << $bits) - 1) * $channels;
        my @data = ( );
        my $i, $v;
        while( length( $row ) >= $chrs * $channels )
        {
          $v = 0;
          for( $i = 0; $i < $channels; $i++ )
          {
            $row =~ s/([0-9A-Fa-f]{$chrs})//;
            $v += "0x$1";
          }
          push( @data, int( $v * 0xFF / $maxval ) );
        }
        push( @{$frames[$frame]}, [@data] ); 
      }
      elsif( $line =~ s/^[^<]*<[^>]*>// ) { }
      else { $line = ""; }
    }
  }
  close F;
}

sub to_flash
{
	my $val = shift;
	my $txt = pack( 'C', (($val >> 4) & 0x0F) + 0x41 ) . pack( 'C', ($val & 0x0F) + 0x41 );
	return $txt;
}

